<?php

function GroupCalendarsAdmin() {

    // draw the form that allows admins to select groups to add to 
    // the event_groups array (stored in $_TABLES['vars'])
    // this function should be placed in public_html/admin/event.php

    global $_TABLES, $USER, $HTTP_POST_VARS;

    if (SEC_hasRights('event.moderate')) {

        // onsubmit calls GroupCalendarsSave($selected_groups) and refreshes page
        if (isset($HTTP_POST_VARS['save_selected_groups'])) {

            $retval .= GroupCalendarsSave($HTTP_POST_VARS['selected_groups']);
        }
        // first build an array of the values already saved
        $old_event_groups = array();
        $sqlresult = DB_query("SELECT value FROM {$_TABLES['vars']} WHERE name = 'event_groups'");
        while ($row = DB_fetchArray ($sqlresult)) { 
            $old_event_groups = explode(",",$row['value']);
        }

        // now build an array of all groups in the system for the menu
        $all_groups = array();
        $sqlresult =  DB_query( "SELECT grp_id,grp_name FROM {$_TABLES['groups']}" );
        while ($row = DB_fetchArray ($sqlresult)) {
            $all_groups[$row['grp_id']] = $row['grp_name'];
        }
        $retval .= '<p>Choose the groups which have their own sub-calendars: <br />';
        $retval .= '<FORM ACTION="' . $PHP_SELF . '" METHOD="POST">';
        $retval .= '<SELECT NAME="selected_groups[]" MULTIPLE SIZE="6">';
        
        // build a list of all the groups, selecting groups that are already in the $events_group array
        while (list($value,$name) = each($all_groups)) {
            if (in_array($value,$old_event_groups)) {
                // option is pre-selected
                $retval .= '<OPTION SELECTED LABEL="' . $name . '" VALUE="' . $value . '">' . $name . '</OPTION>';
            } else {
                // option is not pre-selected
                $retval .= '<OPTION LABEL="' . $name . '" VALUE="' . $value . '">' . $name . '</OPTION>';
            }
        }
            
        $retval .= '</SELECT><INPUT TYPE=SUBMIT NAME="save_selected_groups" VALUE=" Save "></FORM>';
        
    }
    
    return $retval;
}

function GroupCalendarsSave($selected_groups) {
    
    // write the array of $selected_groups into the database
    // this gets called from GroupCalendarsAdmin()
    
    global $_TABLES, $USER;

    if (SEC_hasRights('event.moderate')) {
        // below should also test that $selected_groups are real gid's, just in case
        
        // should test whether event_groups exists, and insert if necessary
        
        $selected_groups_list = implode(",", $selected_groups);
        DB_query("UPDATE {$_TABLES['vars']} SET value = '$selected_groups_list' WHERE name = 'event_groups'");
        $retval .= 'Your choices have been saved.<br />';
    } else {
        // user does not have event moderation privileges!!
        $retval .= 'You must be an event moderator to do this.<br />';
    }

    return $retval;
}

function GroupCalendarsLinks($selected_group){
 
    // create a menu of links to each group calendar
    // this function is called from public_html/calendar.php

    global $_TABLES, $USER, $mode, $view;
    
    $selector_mesg = 'Select an Events Group to View:';

    $url = '/calendar.php?&amp;mode=' . $mode . '&amp;view=' . $view;

    // if $_TABLES['vars'] group_events ! exist exit

    // build an array of the groups saved in the db vars table
    $event_groups = array();
    $sqlresult = DB_query("SELECT value FROM {$_TABLES['vars']} WHERE name = 'event_groups'");
    while ($row = DB_fetchArray ($sqlresult)) { 
        $event_groups = explode(",",$row['value']);
    }

    //  build an array where the index is gid and the value is group's name's for the $event_groups
    // selected_group = 0 means all groups (the original master calendar)
    $group_calendars = array(0=>"All");
    foreach ($event_groups as $thisgroup) {
        $sqlresult =  DB_query( "SELECT grp_name FROM {$_TABLES['groups']} WHERE grp_id=$thisgroup" );
        while ($row = DB_fetchArray ($sqlresult)) {
            $group_calendars[$thisgroup] = $row['grp_name'];
        }
    }

    $retval = '<table class="commenttitle" width="100%" border="0" cellpadding="2">'
                . '<tr><td align="center" class="commentbar1" colspan=' . count($group_calendars) . '>' . $selector_mesg . '</td></tr><tr>';
    
    // build cells with links to each group calendar
    
    while (list($gid,$gname) = each($group_calendars)){
        
        if ($gid == $selected_group) {
            $retval .= '<td align="center" class="commentbar2">' . $gname . '</td>';
        } else {
            // if current group = $selected_group then not a link and bgcolor = different
            $retval .= '<td align="center" class="commentbar1"><a href="' . $url . '&amp;group=' . $gid . '">' . $gname . '</a></td>';
        }
    
    }
    
    $retval .= '</tr></table>';
    
    return $retval;
}

?>
